// Liaison03.pde
// OuvertureXml.pde
// 
// Gerard Paresys Guy Kayser
// 26-1-2015
// Processing 2.0.3
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// Touche Clavier:
//       Z Retour au debut
//       S Sauve l'ecran (format png) "maore-123.png" 123 = Numero frame
//  Espace Pause
//
// Si le dossier data contient les fichiers nommés:
//   XXX.xml  (format Praat TextGrid sauve en UTF8)
//   XXX.wav
//   XXX.jpg  
// le sketch les ouvre
// sinon un selecteur de fichiers s'ouvre, choisir alors un fichier XXX.xml...
// Modifier la ligne 47 au besoin
//
// Le dossier data doit aussi contenir les fichiers:
//
//
// 10 tiers:
//   1 name = "phones"          Phonème
//   2 name = "syll"            Syllabe
//   3 name = "pos"             Catégorie grammaticale
//   4 name = "words"           Mot
//   5 name = "phono"           Phonétique
//   6 name = "ortho"           Transcription
//   7 name = "liaison"         Liaison facultative LF:0 ou LF:1
//   8 name = "liaison-stat"    Liaison facultative réalisée 0% ... 100%
//   9 name = "liaison-pause"   Temps entre deux mots sans liaison
//  10 name = "debit"           mots/seconde


import ddf.minim.*;         // pour AudioPlayer

import java.awt.*;
import java.lang.Object ;
import java.awt.Color ;
import javax.swing.JFrame;  // pour Full Screen Background

String  NomFichierXML = "BA725_est_aussi.xml"; // "BA725_est_aussi.xml"   "BA725_estagreable.xml"

boolean TransTrad     = true;  // Touche T Affiche Transcription <-> Traduction
boolean Verbose       = false;

color   CouleurBackground      = color(255); // Blanc
color   CouleurTexteBas        = color(0, 0, 0);  // 
color   CouleurTexteNomFichier = color(0, 150, 0);  // 
color   CouleurOrange          = color(214, 69, 7);  // 
color   CouleurVert            = color(18, 134, 4);  // 
color   CouleurCercle          = color(200, 200, 200);  // 

color   CouleurLigne      = color(0, 150, 0);      // vert
int     LargeurLigne      =  8;
int     TailleFont        = 18;
int     TailleFontSyllabe = 36;

int     LiaisonPourcent = 75;

int Abcisse= 0;

XML[] Tier1, Tier2, Tier3, Tier4, Tier5, Tier6, Tier7, Tier8, Tier9, Tier10;
int[]  IndexXML = { 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
float[] xmin    = { 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};  // Temps en seconde
String[] Content = {
  "", "", "", "", "", "", "", "", "", "", "",
}; 
int NombreSegment;
String[] LignesPitch;
String[] LignesIntensity;
float[] LignePitch, LigneIntensity;
boolean FichierOuvert = false;

Minim minim;
AudioPlayer player;

// PeasyCam pcam;

float[][] hm  = new float[256][256]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[256][256];
int hmlengthdemi = hm.length / 2;

float MM = 2;         // MM = diametre du worm
//float  M = random(2,7.634);          // zone flou autour worm
boolean Pause = false;
float Temps, TempsPause = 0, TempsDebutPause = 0, Duree;   // en secondes
PFont  FontTexte, FontRuban;

int   x, y, Alea;
float Distance, h;

PImage ImageSpectre,ImageDeco1;
color MonPixel;

int Segment;
float xmax;  // Temps en seconde
String Nom = "";
float Intensite, Pitche = 100, PitcheMini = 1000, PitcheMaxi = 0;
float  FacteurIntensity, FacteurPitch;


void setup() {  
  size(1024, 768); // P3D  OPENGL
  // frame.setBackground(new java.awt.Color(0, 0, 0));
  setPresentBG (0, 0, 0) ;

  // Image1 = loadImage(NomFichierCarte);
  // background(Image1);
  // image(Image1, 0, 0, width, height);

  noStroke();
  frameRate(60); // frameRate(2); // A mettre pour mieux comprendre
  // FontTexte = loadFont("ArialMT-12.vlw");
  FontTexte = createFont("Arial", 12);

  File Fichier = new File(dataPath(NomFichierXML));
  if (Fichier.exists()) {
    Ouverture(NomFichierXML);
    Nom = split(Fichier.getName(), '.')[0];
  }
  else selectInput("select the XML File (format Praat textGrid):", "fileSelected");
}

void draw() {
  // background(CouleurBackground);  // 0 
  // image(Image1, 0, 0, width, height);
ImageDeco1 = loadImage("cache_blanc.png");
  if (! Pause) Temps = (millis() - TempsPause) / 1000.0; //temps en s

  if (FichierOuvert) {

    if (Temps > xmin[1]) {                        // Passage au segment suivant
      IndexXML[1] = IndexXML[1] + 1;
      if (IndexXML[1] < Tier1.length) {
        Content[0] = Tier1[IndexXML[1]].getContent();
        if ((Content[0] == null) || Content[0].equals("_")) IndexXML[1] = IndexXML[1] + 1; //Elimination des caracteres _ qui separe les segments
        else if (! Pause) {
          if (IndexXML[1] < Tier1.length)  xmin[1] = Tier1[IndexXML[1]].getFloat("xmin");
          Content[1] = trim(Content[0]);
          println(Content[1]);
        }
      }
    }
    if (Verbose) println("IndexXML[1] = " + IndexXML[1]);


    if (Temps > xmin[2]) {                        // Passage au segment suivant
      IndexXML[2] = IndexXML[2] + 1;
      if (IndexXML[2] < Tier2.length) {
        Content[0] = Tier2[IndexXML[2]].getContent();
        if ((Content[0] == null) || Content[0].equals("_")) IndexXML[2] = IndexXML[2] + 1; //Elimination des caracteres _ qui separe les segments
        else if (! Pause) {
          if (IndexXML[2] < Tier2.length)  xmin[2] = Tier2[IndexXML[2]].getFloat("xmin");
          Content[2] = trim(Content[0]);
          println(Content[2]);
        }
      }
    }


    if (Temps > xmin[4]) {                        // Passage au segment suivant
      IndexXML[4] = IndexXML[4] + 1;
      if (IndexXML[4] < Tier4.length) {
        Content[0] = Tier4[IndexXML[4]].getContent();
        if ((Content[0] == null) || Content[0].equals("_")) IndexXML[4] = IndexXML[4] + 1; //Elimination des caracteres _ qui separe les segments
        else if (! Pause) {
          if (IndexXML[4] < Tier4.length)  xmin[4] = Tier4[IndexXML[4]].getFloat("xmin");
          Content[4] = trim(Content[0]);
          println(Content[4]);
        }
      }
    }


    //    if (Temps < LignesIntensity.length) {
    //      LigneIntensity = float(split(LignesIntensity[int(Temps * FacteurIntensity)], "   "));
    //      Intensite = LigneIntensity[1];
    //      Intensite = (Intensite - 40) / 12;
    //      Intensite = max(Intensite, 0);
    //      // println("Temps = " + Temps + "      Intensite = " + Intensite);
    //    }

    //    if (Temps < LignesPitch.length) { //le retour du pitch voir Corpus35P2.pde
    //      LignePitch = float(split(LignesPitch[int(Temps * FacteurPitch)], "   "));
    //      if (! Float.isNaN(LignePitch[0]) && ! Float.isNaN(LignePitch[1])) Pitche = LignePitch[1];
    //      //  if (Pitche < PitcheMini) PitcheMini = Pitche;
    //      //  if (Pitche > PitcheMaxi) PitcheMaxi = Pitche;
    //      //  println("PitcheMini = " + PitcheMini + "   PitcheMaxi = " + PitcheMaxi);
    //      //  println("Temps = " + Temps + "      LignePitch[0] = " + LignePitch[0] + "   Pitche = " + Pitche);
    //      MM = ((Pitche - 75) / 85) + 2; // 2 .. 7
    //      // println("MM = "+ MM);
    //    }

    // background(CouleurBackground);
    image(ImageSpectre, 0, 0, width, height);
image(ImageDeco1, 0, 220);
    textFont(FontTexte, TailleFont); 
    fill(CouleurTexteBas); // fill(0, 255, 0); // Texte vert
    textAlign(LEFT); //CENTER
    //    text(Content[2], width/2, 260, 400, 100); // Tier1
    //    text(Content[2], width/2, 360, 400, 100); // Tier0  
    text("Tier5 = " + Tier5[1].getContent(), 10, 460); // Tier0  
    text("Tier6 = " + Tier6[1].getContent(), 10, 490); // Tier0  
    // text("Tier7 = " + Tier7[1].getContent(), 10, 520); // Tier0

      stroke(CouleurLigne);
    strokeWeight(LargeurLigne);
    Abcisse = int(float(width) * Temps / Duree);
    line(Abcisse, 1, Abcisse, height);
    noStroke();
        fill(CouleurCercle);
    ellipse(Abcisse, 550, 80, 80);
        fill(0);
    textAlign(CENTER); //CENTER LEFT
    textFont(FontTexte, TailleFontSyllabe); 
    text(Content[2], Abcisse, 200); // Tier2  

    noStroke();
    fill(255); // blanc
    rect(15, height - 55, width - 15, 20);
    textFont(FontTexte, TailleFont); 
    fill(CouleurTexteNomFichier); 
    textAlign(LEFT); //CENTER
    text(DebutNomFichier, 20, height - 40); // Tier2  

    noStroke();
    fill(CouleurOrange); 
    rect(0, 0, width * LiaisonPourcent / 100, 50);
    fill(CouleurVert); 
    rect(width * LiaisonPourcent / 100, 0, width, 50);


    if (Abcisse > width - LargeurLigne) Pause = true;
  }

  frame.setTitle(Nom + "     " + int(Temps * 10) / 10.0 + " sec     " + int(10 * frameRate) / 10.0 + " fps");
}

void keyPressed() {
  if ( key == ' ') {  // barre d'espace Pause
    Pause = !Pause;
    if (Pause) {
      player.pause();
      TempsDebutPause = millis();
    }
    else {
      player.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else if ( key == 'e' || key == 'E' ) ; // 
  else if ( key == 'z' || key == 'Z' ) {
    //    generateLandscape();
    //    Lissage();
    //    Lissage();
    xmax = 0;
    for (int i = 0; i < IndexXML.length; i = i+1) IndexXML[i] = -1;
    for (int i = 0; i < IndexXML.length; i = i+1) xmin[i] = -1;
    Pause = false;
    TempsPause = millis();
    PlayerAudioDebut();
  }
  else if ( key == 'c' || key == 'C' ) ;  // Touche C   On/Off
  else if ( key == 's' || key == 'S' ) saveFrame(Nom + "-" + frameCount + ".png");
  else if ( key == 'l' || key == 'L' ) ;     // Touche L  On/Off
  else if ( key == 't' || key == 'T' ) TransTrad = !TransTrad; // Touche T  Affiche Transcription <-> Traduction
  else if ( key == 'r' || key == 'R' ) ; //
  else if ( key == 'v' || key == 'V' ) ; //
  else if ( key == 'b' || key == 'B' ) ; //
}

void FinOuverture() {
  minim = new Minim(this);
  player = minim.loadFile(NomFichierAudio, 1024);
  FichierOuvert = true;
  xmax = 0;
  for (int i = 0; i < IndexXML.length; i = i+1) IndexXML[i] = -1;
  for (int i = 0; i < IndexXML.length; i = i+1) xmin[i] = -1;
  //  FacteurIntensity = LignesIntensity.length / LigneIntensity[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 
  //  FacteurPitch = LignesPitch.length / LignePitch[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 
  //  Lissage();
  //  Lissage();
  player.play();
  TempsPause = millis();
  //  println("FinOuverture");
}

void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(NomFichierAudio, 1024);
  player.play();
  TempsPause = millis();
}

void setPresentBG (int r, int g, int b) {
  ((JFrame) frame).getContentPane().setBackground(new Color(r, g, b));
}

